//+------------------------------------------------------------------+
//|                                          Candle-Change-Alert.mq5 |
//|                                          Copyright 2024,JBlanked |
//|                                        https://www.jblanked.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2024,JBlanked"
#property link      "https://www.jblanked.com/trading-tools/"
#property version   "1.00"
#property description "For more trading tools visit www.jblanked.com/trading-tools/"
//--- made by request: https://www.forexfactory.com/thread/post/14996438#post14996438

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_plots 2

#property indicator_label1 "Bullish"
#property indicator_type1 DRAW_HISTOGRAM
#property indicator_color1 clrLime
#property indicator_style1 STYLE_SOLID
#property indicator_width1 2

#property indicator_label2 "Bearish"
#property indicator_type2 DRAW_HISTOGRAM
#property indicator_color2 clrMagenta
#property indicator_style2 STYLE_SOLID
#property indicator_width2 2

#property indicator_minimum 0

double bullish[], bearish[];
datetime lastAlertTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0, bullish, INDICATOR_DATA);
   SetIndexBuffer(1, bearish, INDICATOR_DATA);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int limit = rates_total - prev_calculated;
   if(prev_calculated < 1)
     {
      ArrayInitialize(bullish, EMPTY_VALUE);
      ArrayInitialize(bearish, EMPTY_VALUE);
      ArraySetAsSeries(bullish, true);
      ArraySetAsSeries(bearish, true);
     }
   else
     {
      limit++;
     }
//---
   for(int i = limit - 1; i >= 0; i--)
     {
      bullish[i] = EMPTY_VALUE;
      bearish[i] = EMPTY_VALUE;
      if(iClose(_Symbol, PERIOD_CURRENT, i) > iOpen(_Symbol, PERIOD_CURRENT, i))
        {
         bullish[i] = ((iHigh(_Symbol, PERIOD_CURRENT, i) - iLow(_Symbol, PERIOD_CURRENT, i)) / (_Point * 10));
        }
      else
        {
         bearish[i] = ((iHigh(_Symbol, PERIOD_CURRENT, i) - iLow(_Symbol, PERIOD_CURRENT, i)) / (_Point * 10));
        }
     }
   doAlert();
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
void doAlert()
  {
   if(lastAlertTime == iTime(_Symbol, PERIOD_CURRENT, 1))
     {
      return;
     }
   lastAlertTime = iTime(_Symbol, PERIOD_CURRENT, 1);
   if(bullish[1] != EMPTY_VALUE && bearish[1] == EMPTY_VALUE && bullish[2] == EMPTY_VALUE && bearish[2] != EMPTY_VALUE)
     {
      Alert("Bullish candle change.");
      SendNotification("Bullish candle change.");
     }
   if(bearish[1] != EMPTY_VALUE && bullish[1] == EMPTY_VALUE && bearish[2] == EMPTY_VALUE && bullish[2] != EMPTY_VALUE)
     {
      Alert("Bearish candle change.");
      SendNotification("Bearish candle change.");
     }
  }
//+------------------------------------------------------------------+
